mostly a bunch of fixes
[distro-setup] / brc
1 #!/bin/bash
2 # Copyright (C) 2019 Ian Kelling
3 # SPDX-License-Identifier: AGPL-3.0-or-later
4 # this gets sourced. shebang is just for file mode detection
5
6 # Use source ~/.bashrc instead of doing bash -l when running a script
7 # so this can set extdebug and avoid the bash debugger.
8
9
10 if [[ -s /a/bin/errhandle/err ]]; then
11 # shellcheck source=/a/bin/errhandle/err
12 source /a/bin/errhandle/err
13 # wtf, shellcheck doesn't allow disabling warnings in elifs
14 else
15 # bleh shellcheck can't handle disabling in an elif, so nesting this if.
16 # shellcheck disable=SC2154 # set in .bashrc
17 if [[ -s $bashrc_dir/err ]]; then
18 # shellcheck source=/a/bin/errhandle/err
19 source $bashrc_dir/err
20 fi
21 fi
22
23 # In t8, it runs clear_console for login shells by default. I don't want
24 # my console cleared. And linux ttys get cleared without this.
25 if shopt login_shell >/dev/null && [[ -e ~/.bash_logout ]]; then
26 rm ~/.bash_logout
27 fi
28
29 # if [[ -s /usr/share/bash-completion/completions/git ]]; then
30 # source /usr/share/bash-completion/completions/git
31 # fi
32 # if [[ -s /usr/share/bash-completion/completions/gitk ]]; then
33 # source /usr/share/bash-completion/completions/gitk
34 # fi
35
36 # for testing error catching:
37 # t2() {
38 # echo t2
39 # grep sdf sdfd
40 # echo wtf
41 # }
42 # t1() {
43 # echo t1
44 # t2 a b c
45 # }
46
47 # * settings
48
49 CDPATH=.
50
51
52 # remove all aliases. aliases provided by the system tend to get in the way,
53 # for example, error happens if I try to define a function the same name as an alias
54 unalias -a
55
56 # remove gnome keyring warning messages
57 # there is probably a more proper way, but I didnt find any easily on google
58 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
59 #unset GNOME_KEYRING_CONTROL
60
61 # use extra globing features.
62 shopt -s extglob
63 # include .files when globbing, but ignore files name . and ..
64 # setting this also sets dotglob.
65 export GLOBIGNORE="*/.:*/.."
66
67 # Useful info. see man bash.
68 PS4='$LINENO+ '
69
70
71 # broken with bash_completion package. Saw a bug for this once. dont anymore.
72 # still broken in wheezy
73 # still buggered in latest stable from the web, version 2.1
74 # perhaps its fixed in newer git version, which fails to make for me
75 # this note is from 6-2014.
76 # still broken in flidas.
77 #shopt -s nullglob
78
79 # make tab on an empty line do nothing
80 shopt -s no_empty_cmd_completion
81
82 # fix spelling errors for cd, only in interactive shell
83 shopt -s cdspell
84 # append history instead of overwritting it
85 shopt -s histappend
86 # for compatibility, per gentoo/debian bashrc
87 shopt -s checkwinsize
88 # attempt to save multiline single commands as single history entries.
89 shopt -s cmdhist
90 # enable **
91 shopt -s globstar
92
93
94 # inside emacs fixes
95 if [[ $LC_INSIDE_EMACS ]]; then
96 # EMACS is used by bash on startup, but we dont need it anymore.
97 # plus I hit a bug in a makefile which inherited it
98 unset EMACS
99 export LC_INSIDE_EMACS
100 export PAGER=cat
101 export MANPAGER=cat
102 # scp completion does not work, but this doesnt fix it. todo, figure this out
103 #complete -r scp &> /dev/null
104 # todo, remote file completion fails, figure out how to turn it off
105 export NODE_DISABLE_COLORS=1
106 # This gets rid of ugly terminal escape chars in node repl
107 # sometime, Id like to have completion working in emacs shell for node
108 # the offending chars can be found in lib/readline.js,
109 # things that do like:
110 # stream.write('\x1b[' + (x + 1) + 'G');
111 # We can remove them and keep readline, for example by doing this
112 # to start a repl:
113 #!/usr/bin/env nodejs
114 # var readline = require('readline');
115 # readline.cursorTo = function(a,b,c) {};
116 # readline.clearScreenDown = function(a) {};
117 # const repl = require('repl');
118 # var replServer = repl.start('');
119 #
120 # no prompt, or else readline complete seems to be confused, based
121 # on our column being different? node probably needs to send
122 # different kind of escape sequence that is not ugly. Anyways,
123 # completion doesnt work yet even with the ugly prompt, so whatever
124 #
125 export NODE_NO_READLINE=1
126
127 fi
128
129 export SSH_CONFIG_FILE_OVERRIDE=/root/.ssh/confighome
130
131 # emacs has a different default search path than the info command. This
132 # adds the info defaults to emacs, but not the reverse, because I dun
133 # care much about the cli. The search path is only on the cli if you run
134 # "info xxx", or in emacs if you run '(info xxx)', so not that
135 # important, but might as well fix it.
136
137 # info info says this path is what was compiled, and its not documented
138 # anywhere. Through source grepping, i found it in filesys.h of the info
139 # source in trisquel flidas.
140 #
141 # Traling : means for emacs to add its own stuff on to the end.
142
143 export INFOPATH=$PATH:/usr/local/info:/usr/info:/usr/local/lib/info:/usr/lib/info:/usr/local/gnu/info:/usr/local/gnu/lib/info:/usr/gnu/info:/usr/gnu/lib/info:/opt/gnu/info:/usr/share/info:/usr/share/lib/info:/usr/local/share/info:/usr/local/share/lib/info:/usr/gnu/lib/emacs/info:/usr/local/gnu/lib/emacs/info:/usr/local/lib/emacs/info:/usr/local/emacs/info:.:
144
145 # for openwrt system that has no stty, this is easier than
146 # guarding every time i use it.
147 if ! type -p stty >/dev/null; then
148 stty() { :; }
149 fi
150
151
152 use_color=false
153 if [[ $- == *i* ]]; then
154 # for readline-complete.el
155 if [[ $LC_INSIDE_EMACS ]]; then
156 # all for readline-complete.el
157 stty echo
158 bind 'set horizontal-scroll-mode on'
159 bind 'set print-completions-horizontally on'
160 bind '"\C-i": self-insert'
161 else
162
163
164 if [[ $TERM != dumb ]] && test -t 1; then
165 use_color=true
166 fi
167
168 if [[ $KONSOLE_PROFILE_NAME ]]; then
169 TERM=xterm-256color
170 fi
171
172 if [[ $TERM == alacritty && ! -e /usr/share/terminfo/a/alacritty ]]; then
173 # todo: we should try installing the alacritty terminfo if it is not found
174 # https://github.com/alacritty/alacritty/issues/2838
175 TERM=xterm-256color
176 fi
177
178 # copying from the alacritty example above,
179 if [[ $TERM == xterm-kitty ]]; then
180 if [[ ! -e /usr/share/terminfo/x/xterm-kitty ]]; then
181 TERM=xterm-256color
182 else
183 if [[ -e /a/opt/kitty/shell-integration/bash/kitty.bash ]]; then
184 KITTY_SHELL_INTEGRATION=t
185 source /a/opt/kitty/shell-integration/bash/kitty.bash
186 fi
187 fi
188 fi
189
190 # todo: not sure this works in sakura
191 #stty werase undef
192 #bind "\C-w": kill-region
193 # sakura == xterm-256color
194 # konsole == xterm
195 if [[ $TERM != xterm-kitty && $TERM == xterm* ]]; then
196 # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
197 bind '"\e[1;5C": shell-forward-word' 2>/dev/null
198 bind '"\e[1;5D": shell-backward-word' 2>/dev/null
199 else
200 # make ctrl-backspace work. for konsole, i fixed it through
201 # /home/iank/.local/share/konsole/default.keytab
202 stty werase ^h
203 bind '"\eOc": shell-forward-word'
204 bind '"\eOd": shell-backward-word'
205 fi
206 # i cant remember why i did this, probably to free up some keys to bind
207 # to other things in bash.
208 # other than C-c and C-z, the rest defined by stty -a are, at least in
209 # gnome-terminal, overridden by bash, or disabled by the system
210 stty lnext undef stop undef start undef
211 fi
212
213 fi
214
215 case $TERM in
216 # fixup broken backspace in chroots
217 xterm-kitty|alacritty)
218 chroot() {
219 TERM=xterm-256color command chroot "$@"
220 }
221 ;;
222 esac
223
224 export BC_LINE_LENGTH=0
225
226 # ansible option
227 export PROFILE_TASKS_TASK_OUTPUT_LIMIT=100
228
229 # note, if I use a machine I dont want files readable by all users, set
230 # umask 077 # If fewer than 4 digits are entered, leading zeros are assumed
231
232 # i for insensitive. the rest from
233 # X means dont remove the current screenworth of output upon exit
234 # R means to show colors n things
235 # a useful flag is -F aka --quit-if-one-screen
236 export LESS=RXij12
237 export SYSTEMD_LESS=$LESS
238
239 export NNN_COLORS=2136
240
241 export SL_FILES_DIR=/b/ds/sl/.iank
242 export SL_INFO_DIR=/p/sshinfo
243
244
245 # * include files
246
247 if [[ -s $bashrc_dir/path-add-function ]]; then
248 source $bashrc_dir/path-add-function
249 if [[ $SSH_CLIENT ]]; then
250 if grep -qF /home/iank/.iank/e/e /etc/exports &>/dev/null; then
251 export EMACSDIR=/home/iank/.iank/e/e
252 fi
253 path-add $bashrc_dir
254 fi
255 fi
256
257 # if someone exported $SOE (stop on error), catch errors.
258 #
259 # Note, on debian this results in the following warning when in ssh,
260 # hich I haven't figured out how to fix. It doesn't happen if we source
261 # after the shell has started
262 #
263 # bash: /usr/share/bashdb/bashdb-main.inc: No such file or directory
264 # bash: warning: cannot start debugger; debugging mode disabled
265 if [[ $SOE ]]; then
266 if [[ -e /a/bin/errhandle/err ]]; then
267 source /a/bin/errhandle/err
268 fi
269 fi
270
271
272 mysrc() {
273 local path dir file
274 path=$1
275 dir=${path%/*}
276 file=${path##*/}
277 if [[ -s $path ]]; then
278 # shellcheck disable=SC1090 # this is dynamic, shellcheck can't follow it.
279 source $path
280 elif [[ -s $bashrc_dir/$file ]]; then
281 # shellcheck disable=SC1090 # this is dynamic, shellcheck can't follow it.
282 source $bashrc_dir/$file
283 fi
284 }
285
286
287 mysrc /a/bin/small-misc-bash/ll-function
288 mysrc /a/bin/distro-functions/src/package-manager-abstractions
289
290 # things to remember:
291 # ALT-C - cd into the selected directory
292 # CTRL-T - Paste the selected file path into the command line
293 #
294 # good guide to some of its basic features is the readme file
295 # https://github.com/junegunn/fzf
296
297 # if [[ -s /usr/share/doc/fzf/examples/key-bindings.bash ]]; then
298 # source /usr/share/doc/fzf/examples/key-bindings.bash
299 # fi
300
301 # * functions
302
303 ### begin FSF section ###
304
305 # Comments before functions are meant to be good useful
306 # documentation. If they fail at that, please improve them or send Ian a
307 # note.
308
309 ## copy bash completion
310 # Usage: ORIGINAL_COMMAND TARGET_COMMAND...
311 #
312 # It copies how the bash completion works from one command to other
313 # commands.
314 ccomp() {
315 local c src
316 src=$1
317 shift
318 if ! c=$(complete -p $src 2>/dev/null); then
319 _completion_loader $src &>/dev/null ||:
320 c=$(complete -p $src 2>/dev/null) || return 0
321 fi
322 # remove $src( .*|$)
323 c=${c% "$src"}
324 c=${c%% "$src" *}
325 eval $c $*
326 }
327
328 ## directory history tracking and navigation.
329 #
330 # cd becomes a function, also aliased to c. b to go back, f to go
331 # forward, cl to list recent directories and choose one.
332 #
333 # The finer details you may want to skip:
334 #
335 # We also define bl to print the list of back and forward directories.
336 #
337 # We keep 2 stacks, forward and back. Unlike with a web browser, the
338 # forward stack is not erased when going somewhere new.
339 #
340 # Recent directories are stored in ~/.cdirs.
341 #
342 declare -a _dir_forward _dir_back
343 c() {
344 # normally, the top of _dir_back is our current dir. if it isn't,
345 # put it on there, except we don't want to do that when we
346 # just launched a shell
347 if [[ $OLDPWD ]]; then
348 if (( ${#_dir_back[@]} == 0 )) || [[ ${_dir_back[-1]} != "$PWD" ]]; then
349 _dir_back+=("$PWD")
350 fi
351 fi
352 command cd "$@"
353 if (( ${#_dir_back[@]} == 0 )) || [[ ${_dir_back[-1]} != "$PWD" ]]; then
354 _dir_back+=("$PWD")
355 fi
356 echo "$PWD" >> ~/.cdirs
357 }
358 ccomp cd c
359
360 # back
361 b() {
362 local top_back
363 if (( ${#_dir_back[@]} == 0 )); then
364 echo "nothing left to go back to" >&2
365 return 0
366 fi
367 top_back="${_dir_back[-1]}"
368
369 if [[ $top_back == "$PWD" ]] && (( ${#_dir_back[@]} == 1 )); then
370 echo "already on last back entry" >&2
371 return 0
372 fi
373
374
375 if [[ $top_back == "$PWD" ]]; then
376 # add to dirf if not already there
377 if (( ${#_dir_forward[@]} == 0 )) || [[ ${_dir_forward[-1]} != "$top_back" ]]; then
378 _dir_forward+=("$top_back")
379 fi
380 unset "_dir_back[-1]"
381 command cd "${_dir_back[-1]}"
382 else
383 if (( ${#_dir_forward[@]} == 0 )) || [[ ${_dir_forward[-1]} != "$PWD" ]]; then
384 _dir_forward+=("$PWD")
385 fi
386 command cd "$top_back"
387 fi
388
389 # Interesting feature, not sure I want it.
390 # give us a peek at what is next in the list
391 # if (( ${#_dir_back[@]} >= 2 )); then
392 # printf "%s\n" "${_dir_back[-2]}"
393 # fi
394 #
395
396 # c/b/f Implementation notes:
397 #
398 # The top of the back is $PWD
399 # as long as the last directory change was due to c,b,or cl.
400 #
401 # Example of stack changes:
402 #
403 # a b c (d)
404 ## back
405 # a b (c)
406 # d
407 #back
408 #a (b)
409 #d c
410 #back
411 #(a)
412 #d c b
413 #forward
414 #a (b)
415 #d c
416 #
417 # a b c
418 ## back
419 # a b
420 # (c)
421 ## forward
422
423 }
424 # forward
425 f() {
426 local top_forward
427 if (( ${#_dir_forward[@]} == 0 )); then
428 echo "no forward dir left" >&2
429 return 0
430 fi
431 top_forward="${_dir_forward[-1]}"
432 unset "_dir_forward[-1]"
433 c "$top_forward"
434
435 # give us a peek at what is next in the list
436 # if (( ${#_dir_forward[@]} )); then
437 # printf "%s\n" "${_dir_forward[-1]}"
438 # fi
439 }
440 # cd list
441 cl() {
442 local i line input start
443 local -A buttondirs alines
444 local -a buttons dirs lines
445 buttons=( {a..z} {2..9} )
446 if [[ ! -s ~/.cdirs ]]; then
447 echo nothing in ~/.cdirs
448 return 0
449 fi
450
451 i=0
452
453 mapfile -t lines <~/.cdirs
454 start=$(( ${#lines[@]} - 1 ))
455
456 # we have ~33 buttons as of this writing, so lets
457 # prune down the history every once in a while.
458 if (( start > 500 )); then
459 tac ~/.cdirs | awk '!seen[$0]++' | head -n 200 | tac | sponge ~/.cdirs || [[ $? == 141 ]]
460 fi
461
462 for (( j=start; j >= 0; j-- )); do
463 line="${lines[$j]}"
464 if [[ ! $line || ${alines[$line]} || ! -d "$line" || $line == "$PWD" || line == "$HOME" ]]; then
465 continue
466 fi
467 alines[$line]=t
468 buttondirs[${buttons[i]}]="$line"
469 printf "%s %s\n" ${buttons[i]} "$line"
470 if (( i == ${#buttons[@]} - 1 )); then
471 break
472 fi
473 i=$(( i + 1 ))
474 done
475
476 if (( i == 0 )); then
477 echo "no dirs in ~/.cdirs"
478 return 0
479 fi
480 read -r -N 1 input
481 if [[ $input != $'\n' ]]; then
482 c "${buttondirs[$input]}"
483 fi
484 }
485 # back list
486 bl() {
487 local start i j max
488 max=10
489 start=$(( ${#_dir_back[@]} - 1 ))
490
491 # cleanup possible repeating of pwd
492 if (( start >= 0 )) && [[ ${_dir_back[$start]} == "$PWD" ]]; then
493 start=$(( start - 1 ))
494 fi
495 j=1
496 if (( start >= 0 )); then
497 for (( i=start; i >= 0 ; i-- )); do
498 printf "%s %s\n" $j ${_dir_back[i]}
499 j=$(( j + 1 ))
500 if (( j >= max )); then
501 break
502 fi
503 done
504 fi
505
506 max=10
507 start=$(( ${#_dir_forward[@]} - 1 ))
508
509 # cleanup possible repeating of pwd
510 if (( start >= 0 )) && [[ ${_dir_forward[$start]} == "$PWD" ]]; then
511 start=$(( start - 1 ))
512 fi
513 if (( start < 0 )); then
514 return 0
515 fi
516 echo --
517 j=1
518 for (( i=start; i >= 0 ; i-- )); do
519 printf "%s %s\n" $j ${_dir_forward[i]}
520 j=$(( j + 1 ))
521 if (( j >= max )); then
522 break
523 fi
524 done
525 }
526
527 # pee do. run args as a command with output copied to syslog.
528 #
529 # Usage: pd [-t TAG] COMMAND...
530 #
531 # -t TAG Override the tag in the syslog. The default is COMMAND with
532 # any path part is removed, eg. for /bin/cat the tag is cat.
533 #
534 # You can view the log via "journalctl -t TAG"
535 pd() {
536 local tag ret
537 ret=0
538 tag=${1##*/}
539 case $1 in
540 -t) tag="$2"; shift 2 ;;
541 esac
542 echo "PWD=$PWD command: $*" | logger -t $tag
543 "$@" |& pee cat "logger -t $tag" || ret=$?
544 echo "exited with status=$ret" | pee cat "logger -t $tag"
545 # this avoids any err-catch
546 (( ret == 0 )) || return $ret
547 }
548 ccomp time pd
549
550 # jdo = journal do. Run command as transient systemd service, tailing
551 # its output in the journal until it completes.
552 #
553 # Usage: jdo COMMAND...
554 #
555 # Compared to pd: commands recognize this is a non-interactive shell.
556 # The service is unaffected if our ssh connection dies, no need to run
557 # in screen or tmux.
558 #
559 # Note: The last few lines of any existing entries for a unit by that
560 # name will be output first, and there will be a few second delay at the
561 # start of the command, and a second or so at the end.
562 #
563 # Note: Functions and aliases obviously won't work, we resolve the
564 # command to a file.
565 #
566 # Note: requires running as root.
567 jdo() {
568 local cmd cmd_name jr_pid ret
569 ret=0
570 cmd="$1"
571 shift
572 if [[ $EUID != 0 ]]; then
573 echo "jdo: error: rerun as root"
574 return 1
575 fi
576 cmd_name=${cmd##*/}
577 if [[ $cmd != /* ]]; then
578 cmd=$(type -P "$cmd")
579 fi
580 # -q = quiet
581 journalctl -qn2 -f -u "$cmd_name" &
582 # Trial and error of time needed to avoid missing initial lines.
583 # .5 was not reliable. 1 was not reliable. 2 was not reliable
584 sleep 4
585 jr_pid=$!
586 systemd-run --unit "$cmd_name" --wait --collect "$cmd" "$@" || ret=$?
587 # The sleep lets the journal output its last line
588 # before the prompt comes up.
589 sleep .5
590 kill $jr_pid &>/dev/null ||:
591 unset jr_pid
592 fg &>/dev/null ||:
593 # this avoids any err-catch
594 (( ret == 0 )) || return $ret
595 }
596 ccomp time jdo
597 #### end fsf section
598
599
600 ..() { c ..; }
601 ...() { c ../..; }
602 ....() { c ../../..; }
603 .....() { c ../../../..; }
604 ......() { c ../../../../..; }
605
606 chere() {
607 local f path
608 for f; do
609 path=$(readlink -e "$f")
610 echo "cat >$path <<'EOF'"
611 cat "$f"
612 echo EOF
613 done
614 }
615
616
617 # file cut copy and paste, like the text buffers :)
618 # I havnt tested these.
619 _fbufferinit() { # internal use
620 ! [[ $my_f_tempdir ]] && my_f_tempdir="$(mktemp -d)"
621 rm -rf "${my_f_tempdir:?}"/*
622 }
623 fcp() { # file cp
624 _fbufferinit
625 cp "$@" "$my_f_tempdir"/
626 }
627 fct() { # file cut
628 _fbufferinit
629 mv "$@" "$my_f_tempdir"/
630 }
631 fpst() { # file paste
632 [[ $2 ]] && { echo too many arguments; return 1; }
633 target=${1:-.}
634 cp "$my_f_tempdir"/* "$target"
635 }
636
637 _khfix_common() {
638 local host ip port file key
639 read -r host ip port < <(timeout -s 9 2 ssh -oBatchMode=yes -oControlMaster=no -oControlPath=/ -v $1 |& sed -rn "s/debug1: Connecting to ([^ ]+) \[([^\]*)] port ([0-9]+).*/\1 \2 \3/p" ||: )
640 file=$(readlink -f ~/.ssh/known_hosts)
641 if [[ ! $ip ]]; then
642 echo "khfix: ssh failed"
643 return 1
644 fi
645 if [[ $port != 22 ]]; then
646 ip_entry="[$ip]:$port"
647 host_entry="[$host]:$port"
648 else
649 ip_entry=$ip
650 host_entry=$host
651 fi
652 if [[ $host != "$ip" ]]; then
653 key=$(ssh-keygen -F "$host_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
654 if [[ $key ]]; then
655 grep -Fv "$key" "$file" | sponge "$file"
656 fi
657 fi
658 key=$(ssh-keygen -F "$ip_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
659 if [[ $key ]]; then
660 grep -Fv "$key" "$file" | sponge "$file"
661 fi
662 ll ~/.ssh/known_hosts
663 rootsshsync
664 }
665 khfix() { # known hosts fix
666 _khfix_common "$@" || return 1
667 ssh $1 :
668 }
669 khcopy() {
670 _khfix_common "$@"
671 ssh-copy-id $1
672 }
673
674 # ya, hacky hardcoded hostnames in 2023. we could do better
675 hssh-update() {
676 local -a failed_hosts hosts
677 case $HOSTNAME in
678 sy|kd)
679 hosts=(
680 kd x3.office.fsf.org syw
681 )
682 ;;
683 x3)
684 hosts=(
685 b8.nz sywg.b8.nz
686 )
687 ;;
688 esac
689 for host in ${hosts[@]}; do
690 e $host
691 if ! scp /b/fai/fai/config/files/usr/local/bin/hssh/IANK root@$host:/usr/local/bin/hssh; then
692 failed_hosts+=($host)
693 fi
694 done
695 if (( ${#failed_hosts[@]} >= 1 )); then
696 echo failed_hosts=${failed_hosts[*]}
697 return 1
698 fi
699 }
700
701 a() {
702 local x
703 x=$(readlink -nf "${1:-$PWD}")
704 # yes, its kinda dumb that xclip/xsel cant do this in one invocation
705 echo -n "$x" | xclip -selection clipboard
706 echo -n "$x" | xclip
707 }
708
709 # a1 = awk {print $1}
710 for field in {1..20}; do
711 eval a$field"() { awk '{print \$$field}'; }"
712 done
713 # h1 = head -n1
714 for num in {1..9}; do
715 eval h$num"() { head -n$num; }"
716 done
717
718
719 hexipv4() {
720 # shellcheck disable=SC2046 disable=SC2001 disable=SC2183 # hacks, expected
721 printf '%d.%d.%d.%d\n' $(echo $1 | sed 's/../0x& /g')
722 }
723
724 vp9() {
725 local f out outdir in fname origdir skip1
726 origdir="$PWD"
727 outdir=vp9
728 skip1=false
729 while [[ $1 == -* ]]; do
730 case $1 in
731 # if we got interrupted after 1st phase
732 -2)
733 skip1=true
734 shift
735 ;;
736 --out)
737 outdir=$2
738 shift 2
739 ;;
740 esac
741 done
742 m mkdir -p $outdir
743 # first pass only uses about 1 cpu, so run in parallel
744 for f; do
745 {
746 fname="${f##*/f}"
747 if [[ $f == /* ]]; then
748 in="$f"
749 else
750 in=$origdir/$f
751 fi
752 out="$origdir/$outdir/$fname"
753 mkdir -p /tmp/vp9/$fname
754 cd /tmp/vp9/$fname
755 if ! $skip1 && [[ ! -s ffmpeg2pass-0.log ]]; then
756 # -nostdin or else wait causes ffmpeg to go into stopped state. dunno why, random stackoverflow answer.
757 m ffmpeg -nostdin -hide_banner -loglevel error -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 1 -an -f null /dev/null
758 fi
759 if [[ -e $out ]]; then rm -f $out; fi
760 m ffmpeg -nostdin -hide_banner -loglevel error -y -i $in -g 192 -vcodec libvpx-vp9 -tile-rows 2 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 2 -c:a libvorbis -qscale:a 5 $out
761 } &
762 done
763 wait -f
764 cd "$origdir"
765 }
766
767 utcl() { # utc 24 hour time to local hour 24 hour time
768 echo "print( ($1 $(date +%z | sed -r 's/..$//;s/^(-?)0*/\1/')) % 24)"|python3
769 }
770
771 bwm() {
772 s bwm-ng -T avg -d
773 }
774
775
776 # for running in a fai rescue. iank specific.
777 kdrescue() {
778 d=vgata-Samsung_SSD_850_EVO_2TB_S2RLNX0J502123D
779 for f in $d vgata-Samsung_SSD_870_QVO_8TB_S5VUNG0N900656V; do
780 cryptsetup luksOpen --key-file /p /dev/$f/root crypt-$f-root
781 cryptsetup luksOpen --key-file /p /dev/$f/o crypt-$f-o
782 done
783 mount -o subvol=root_trisquelaramo /dev/mapper/crypt-$d-root /mnt
784 mount -o subvol=a /dev/mapper/crypt-$d-root /mnt/a
785 mount -o subvol=o /dev/mapper/crypt-$d-o /mnt/o
786 mount -o subvol=boot_trisquelaramo /dev/sda2 /mnt/boot
787 cd /mnt
788 chrbind
789 }
790
791
792
793
794 c4() { c /var/log/exim4; }
795
796 caa() { git commit --amend --no-edit -a; }
797
798 cf() {
799 for f; do
800 hr
801 echo "$f"
802 hr
803 cat "$f"
804 done
805 }
806 caf() {
807 # shellcheck disable=SC2033
808 find -L "$@" -type f -not \( -name .svn -prune -o -name .git -prune \
809 -o -name .hg -prune -o -name .editor-backups -prune \
810 -o -name .undo-tree-history -prune \) \
811 -exec bash -c '. ~/.bashrc; hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
812
813 }
814 ccomp cat cf caf
815
816 calc() { echo "scale=3; $*" | bc -l; }
817 # no having to type quotes, but also no command history:
818 clc() {
819 local x
820 read -r x
821 echo "scale=3; $x" | bc -l
822 }
823
824 cam() {
825 git commit -am "$*"
826 }
827
828 ccat () { # config cat. see a config without extra lines.
829 sed -r '/^[[:space:]]*([;#]|--|\/\/|$)/d' "$@"
830 }
831 ccomp grep ccat
832
833 chrbind() {
834 local d
835 # dev/pts needed for pacman signature check
836 for d in dev proc sys dev/pts; do
837 [[ -d $d ]]
838 if ! mountpoint $d &>/dev/null; then
839 m s mount -o bind /$d $d
840 fi
841 done
842 }
843 chumount() {
844 local d
845 # dev/pts needed for pacman signature check
846 for d in dev/pts dev proc sys; do
847 [[ -d $d ]]
848 if mountpoint $d &>/dev/null; then
849 m s umount $d
850 fi
851 done
852 }
853
854
855 _cdiff-prep() {
856 # join options which are continued to multiples lines onto one line
857 local first=true
858 while IFS= read -r line; do
859 # remove leading spaces/tabs. assumes extglob
860 if [[ $line == "[ ]*" ]]; then
861 line="${line##+( )}"
862 fi
863 if $first; then
864 pastline="$line"
865 first=false
866 elif [[ $line == *=* ]]; then
867 echo "$pastline" >> "$2"
868 pastline="$line"
869 else
870 pastline="$pastline $line"
871 fi
872 done < <(grep -vE '^([ \t]*#|^[ \t]*$)' "$1")
873 echo "$pastline" >> "$2"
874 }
875
876 cdiff() {
877 # diff config files,
878 # setup for format of postfix, eg:
879 # option = stuff[,]
880 # [more stuff]
881 local pastline unified f1 f2
882 unified="$(mktemp)"
883 f1="$(mktemp)"
884 f2="$(mktemp)"
885 _cdiff-prep "$1" "$f1"
886 _cdiff-prep "$2" "$f2"
887 cat "$f1" "$f2" | grep -Po '^[^=]+=' | sort | uniq > "$unified"
888 while IFS= read -r line; do
889 # the default bright red / blue doesnt work in emacs shell
890 dwdiff -cblue,red -A best -d " ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
891 done < "$unified"
892 }
893
894
895 cat-new-files() {
896 local start=$SECONDS
897 local dir="$1"
898 # shellcheck disable=SC2030
899 inotifywait -m "$dir" -e create -e moved_to | \
900 while read -r filedir _ file; do
901 cat "$filedir$file"
902 hr
903 calc $((SECONDS - start)) / 60
904 sleep 5
905 done
906
907 }
908
909 chownme() {
910 s chown -R $USER:$USER "$@"
911 }
912
913 # shellcheck disable=SC2032
914 chown() {
915 # makes it so chown -R symlink affects the symlink and its target.
916 if [[ $1 == -R ]]; then
917 shift
918 command chown -h "$@"
919 command chown -R "$@"
920 else
921 command chown "$@"
922 fi
923 }
924
925 cim() {
926 git commit -m "$*"
927 }
928
929
930 d() { builtin bg "$@"; }
931 ccomp bg d
932
933 # f would be more natural, but i already am using it for something
934 z() { builtin fg "$@"; }
935 ccomp fg z
936
937 x() { builtin kill %%; }
938
939 dc() {
940 diff --strip-trailing-cr -w "$@" # diff content
941 }
942 ccomp diff dc
943
944 despace() {
945 local x y
946 for x in "$@"; do
947 y="${x// /_}"
948 safe_rename "$x" "$y"
949 done
950 }
951
952 # df progress
953 # usage: dfp MOUNTPOINT [SECOND_INTERVAL]
954 # SECOND_INTERVAL defaults to 90
955 dfp() {
956 # mp = mountpoint
957 local a b mp interval
958 mp=$1
959 interval=${2:-90}
960 if [[ ! $mp ]]; then
961 echo "dfp: error, missing 1st arg" >&2
962 return 1
963 fi
964 while true; do
965 a=$(df --output=used $mp | tail -n1)
966 sleep $interval
967 b=$(df --output=used $mp | tail -n1)
968 printf "used mib: %'d mib/min: %s\n" $(( b /1000 )) $(( (b-a) / (interval * 1000 / 60 ) ))
969 done
970 }
971
972 # get ipv4 ip from HOST. or if it is already a number, return that
973 hostip() {
974 local host="$1"
975 case $host in
976 [0-9:])
977 echo "$host"
978 ;;
979 *)
980 getent ahostsv4 "$host" | awk '{ print $1 }' | head -n1
981 ;;
982 esac
983 }
984
985 dig() {
986 command dig +nostats +nocmd "$@"
987 }
988 # Output with sections sorted, and removal of query id, so 2 dig outputs can be diffed.
989 digsort() {
990 local sec
991 sec=
992 dig +nordflag "$@" | sed -r 's/^(;; ->>HEADER<<-.*), id: .*/\1/' | while read -r l; do
993 if [[ $l == [^\;]* ]]; then
994 sec+="$l"$'\n'
995 else
996 if [[ $sec ]]; then
997 printf "%s" "$sec" | sort
998 sec=
999 fi
1000 printf "%s\n" "$l"
1001 fi
1002 done
1003 }
1004 ccomp dig digsort
1005 # compare digs to the 2 servers
1006 # usage: digdiff @server1 @server2 DIG_ARGS
1007 # note: only the soa master nameserver will respond with
1008 # ra "recursive answer" flag. That difference is meaningless afaik.
1009 digdiff() {
1010 local s1 s2
1011 s1=$1
1012 shift
1013 s2=$1
1014 shift
1015 digsort $s1 "$@" | tee /tmp/digdiff
1016 diff -u /tmp/digdiff <(digsort $s2 "$@")
1017 }
1018
1019 # date in a format i like reading
1020 dt() {
1021 date "+%A, %B %d, %r" "$@"
1022 }
1023 dtr() {
1024 date -R "$@"
1025 }
1026 # date with all digits in a format i like
1027 dtd() {
1028 date +%F_%T% "$@"
1029 }
1030 ccomp date dt dtr dtd
1031
1032 dus() { # du, sorted, default arg of
1033 du -sh ${@:-*} | sort -h
1034 }
1035 ccomp du dus
1036
1037
1038 e() { printf "%s\n" "$*"; }
1039
1040 # echo args
1041 ea() {
1042 if (( ! $# )); then
1043 echo no args
1044 fi
1045 for arg; do
1046 printf "%qEOL\n" "${arg}"
1047 printf "%s" "${arg}" |& hexdump -C
1048 done
1049 }
1050
1051 # echo variables. print var including escapes, etc, like xxd for variable
1052 ev() {
1053 if (( ! $# )); then
1054 echo no args
1055 fi
1056 for arg; do
1057 if [[ -v $arg ]]; then
1058 printf "%qEOL\n" "${!arg}"
1059 printf "%s" "${!arg}" |& hexdump -C
1060 else
1061 echo arg $arg is unset
1062 fi
1063 done
1064 }
1065
1066 ediff() {
1067 [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
1068 emacs --eval "(ediff-files \"$1\" \"$2\")"
1069 }
1070
1071 # mail related
1072 # shellcheck disable=SC2120 # we expect to pass arguments in use outside this file
1073 etail() {
1074 ngset
1075 tail -F /var/log/exim4/mainlog /var/log/exim4/*main /var/log/exim4/paniclog /var/log/exim4/*panic -n 200 "$@"
1076 ngreset
1077 }
1078 etailm() {
1079 tail -F /var/log/exim4/mainlog -n 200 "$@"
1080 }
1081 etail2() {
1082 tail -F /var/log/exim4/mymain -n 200 "$@"
1083 }
1084 ccomp tail etail etail2
1085
1086 # ran into this online, trying it out
1087 detach() {
1088 ( "$@" &>/dev/null & disown )
1089 }
1090
1091 showkeys() {
1092 ssh "$@" cat .ssh/authorized_keys{,2}
1093 }
1094
1095
1096 # print exim old pids
1097 eoldpids() {
1098 local configtime pid piduptime now daemonpid
1099 printf -v now '%(%s)T' -1
1100 configtime=$(stat -c%Y /var/lib/exim4/config.autogenerated)
1101 if [[ -s /run/exim4/exim.pid ]]; then
1102 daemonpid=$(cat /run/exim4/exim.pid)
1103 fi
1104 for pid in $(pgrep -f '^/usr/sbin/exim4( |$)'); do
1105 # the daemonpid gets reexeced on HUP (service reloads), keeping its same old timestamp
1106 if [[ $pid == "$daemonpid" ]]; then
1107 continue
1108 fi
1109 piduptime=$(awk -v ticks="$(getconf CLK_TCK)" 'NR==1 { now=$1; next } END { printf "%9.0f\n", now - ($20/ticks) }' /proc/uptime RS=')' /proc/$pid/stat) ||: # sometimes pids disappear pretty fast
1110 if (( configtime > now - piduptime )); then
1111 echo $pid
1112 fi
1113 done
1114 }
1115
1116 # exim tail but only watch lines from new pids
1117 etailnew() {
1118 local pid oldpids
1119 for pid in $(eoldpids); do
1120 oldpids+="$pid|"
1121 done
1122 if [[ $oldpids ]]; then
1123 etail | awk '$3 !~ /^\[('"${oldpids%|}"')\]$/'
1124 else
1125 etail
1126 fi
1127 }
1128 # exim watch as old pids go away
1129 ewatchold() {
1130 local configtime pid piduptime now tmpstr
1131 local -i count
1132 local -a oldpids
1133 count=0
1134 while true; do
1135 tmpstr=$(eoldpids)
1136 mapfile -t oldpids <<<"$tmpstr"
1137 if (( ! ${#oldpids[@]} )); then
1138 return
1139 fi
1140 # print the date every 20 iterations
1141 if (( ! count % 20 )); then
1142 date
1143 fi
1144 count+=1
1145 ps -f -p "${oldpids[*]}"
1146 sleep 1
1147 done
1148 }
1149
1150 eless() {
1151 less /var/log/exim4/mainlog
1152 }
1153 ccomp less eless
1154 eqcat() {
1155 exiqgrep -ir.\* -o 60 | while read -r i; do
1156 hlm exim -Mvc $i
1157 echo
1158 hlm exigrep $i /var/log/exim4/mainlog | cat ||:
1159 done
1160 }
1161 eqrmf() {
1162 # other ways to get the list of message ids:
1163 # exim -bp | awk 'NF == 4 {print $3}'
1164 # # this is slower 160ms, vs 60.
1165 # exipick -i
1166 exiqgrep -ir.\* | xargs exim -Mrm
1167 }
1168
1169 econfdevnew() {
1170 rm -rf /tmp/edev
1171 mkdir -p /tmp/edev/etc
1172 cp -ra /etc/exim4 /tmp/edev/etc
1173 cp -ra /etc/alias* /tmp/edev/etc
1174 find /tmp/edev/etc/exim4 -type f -execdir sed -i "s,/etc/,/tmp/edev/etc/,g" '{}' +
1175 econfdev
1176 }
1177 econfdev() {
1178 update-exim4.conf -d /tmp/edev/etc/exim4 -o /tmp/edev/e.conf
1179 }
1180
1181 # exim grep in
1182 # show important information about incoming mail in the exim log
1183 egrin() {
1184 sed -rn '/testignore|jtuttle|eximbackup/!s/^[^ ]+ ([^ ]+) [^ ]+ [^ ]+ <= ([^ ]+).*T="(.*)" from (<[^ ]+> .*$)/\1 \4\n \3/p' <${1:-/var/log/exim4/mainlog}
1185 }
1186
1187 # 2nd line is message-id:
1188 egrinid() {
1189 sed -rn '/testignore|jtuttle|eximbackup/!s/^[^ ]+ ([^ ]+) [^ ]+ [^ ]+ <= ([^ ]+).* id=([^ ]+) T="(.*)" from (<[^ ]+> .*$)/\1 \5\n \3\n \4/p' <${1:-/var/log/exim4/mainlog}
1190 }
1191 etailin() {
1192 tail -F /var/log/exim4/mainlog | sed -rn '/testignore|jtuttle|eximbackup/!s/^[^ ]+ ([^ ]+) [^ ]+ [^ ]+ <= ([^ ]+).*T="(.*)" from (<[^ ]+> .*$)/\1 \4\n \3/p'
1193 }
1194
1195
1196
1197
1198 fa() {
1199 # find array. make an array of file names found by find into $x
1200 # argument: find arguments
1201 # return: find results in an array $x
1202 while read -rd ''; do
1203 x+=("$REPLY");
1204 done < <(find "$@" -print0);
1205 }
1206
1207 faf() { # find all files. use -L to follow symlinks
1208 find "$@" -not \( -name .svn -prune -o -name .git -prune \
1209 -o -name .hg -prune -o -name .editor-backups -prune \
1210 -o -name .undo-tree-history -prune \) -type f 2>/dev/null
1211 }
1212
1213 # usage ffconcat FILES_TO_CONCAT OUTPUT_FILE
1214 ffconcat() {
1215 local tmpf
1216 tmpf=$(mktemp)
1217 printf "file '%s'\n" "$1" >$tmpf
1218 while (( $# > 1 )); do
1219 shift
1220 printf "file '%s'\n" "$1" >>$tmpf
1221 done
1222 # https://trac.ffmpeg.org/wiki/Concatenate
1223 ffmpeg -f concat -safe 0 -i $tmpf -c copy "$1"
1224 rm $tmpf
1225 }
1226 ffremux() {
1227 local tmpf tmpd
1228 if (( $# == 0 )); then
1229 echo ffremux error expected args >&2
1230 return 1
1231 fi
1232 tmpd="$(mktemp -d)"
1233 for f; do
1234 tmpf=$tmpd/"${f##*/}"
1235 ffmpeg -i "$f" -c:v copy -c:a copy $tmpf
1236 cat $tmpf >"$f"
1237 done
1238 rm -r $tmpd
1239 }
1240
1241
1242
1243 # absolute path of file/dir without resolving symlinks.
1244 #
1245 # Most of the time, I want this where I would normally use readlink.
1246 # This is what realpath -s does in most cases, but sometimes it
1247 # actually resolves symlinks, at least when they are in /.
1248 #
1249 # Note, if run on a dir, if the final component is relative, it won't
1250 # resolve that. Use the below fpd for that.
1251 #
1252 # note: we could make a variation of this which
1253 # assigns to a variable name using eval, so that we don't have to do
1254 # x=$(fp somepath), which might save subshell overhead and look nice,
1255 # but I'm not going to bother.
1256 fp() {
1257 local initial_oldpwd initial_pwd dir base
1258 initial_oldpwd="$OLDPWD"
1259 initial_pwd="$PWD"
1260 if [[ $1 == */* ]]; then
1261 dir="${1%/*}"
1262 base="/${1##*/}"
1263 # CDPATH because having it set will cause cd to possibly print output
1264 CDPATH='' cd "$dir"
1265 printf "%s%s\n" "$PWD" "$base"
1266 CDPATH='' cd "$initial_pwd"
1267 OLDPWD="$initial_oldpwd"
1268 else
1269 printf "%s/%s\n" "$PWD" "$1"
1270 fi
1271 }
1272 # full path of directory without resolving symlinks
1273 fpd() {
1274 local initial_oldpwd initial_pwd dir
1275 initial_oldpwd="$OLDPWD"
1276 initial_pwd="$PWD"
1277 dir="$1"
1278 CDPATH='' cd "$dir"
1279 printf "%s%s\n" "$PWD" "$base"
1280 cd "$initial_pwd"
1281 OLDPWD="$initial_oldpwd"
1282 }
1283
1284
1285 # mail related
1286 frozen() {
1287 rm -rf /tmp/frozen
1288 sudo mailq |gr frozen|awk '{print $3}' | while read -r id; do
1289 sudo exim -Mvl $id
1290 echo
1291 sudo exim -Mvh $id
1292 echo
1293 sudo exim -Mvb $id
1294 echo -e '\n\n##############################\n'
1295 done | tee -a /tmp/frozen
1296 }
1297 frozenrm() {
1298 local ids=()
1299 while read -r line; do
1300 printf '%s\n' "$line"
1301 ids+=("$(printf '%s\n' "$line" |gr frozen|awk '{print $3}')")
1302 done < <(s mailq)
1303 echo "sleeping for 2 in case you change your mind"
1304 sleep 2
1305 sudo exim -Mrm "${ids[@]}"
1306 }
1307
1308 funce() {
1309 # like -e for functions. returns on error.
1310 # at the end of the function, disable with:
1311 # trap ERR
1312 trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
1313 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\" }\$?=$?"
1314 trap ERR
1315 return' ERR
1316 }
1317
1318 getdir () {
1319 local help="Usage: getdir [--help] PATH
1320 Output the directory of PATH, or just PATH if it is a directory."
1321 if [[ $1 == --help ]]; then
1322 echo "$help"
1323 return 0
1324 fi
1325 if [[ $# -ne 1 ]]; then
1326 echo "getdir error: expected 1 argument, got $#"
1327 return 1
1328 fi
1329 if [[ -d $1 ]]; then
1330 echo "$1"
1331 else
1332 local dir
1333 dir="$(dirname "$1")"
1334 if [[ -d $dir ]]; then
1335 echo "$dir"
1336 else
1337 echo "getdir error: directory does not exist"
1338 return 1
1339 fi
1340 fi
1341 }
1342
1343 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
1344 [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
1345 local root
1346 root=$(gitroot) || return 1 # function to set gitroot
1347 builtin cd "$root"
1348 git symbolic-ref HEAD refs/heads/$1
1349 rm .git/index
1350 git clean -fdx
1351 }
1352
1353 # shellcheck disable=SC2120
1354 gitroot() {
1355 local help="Usage: gitroot [--help]
1356 Print the full path to the root of the current git repo
1357
1358 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
1359 and works in older versions of git which did not have that."
1360 if [[ $1 == --help ]]; then
1361 echo "$help"
1362 return
1363 fi
1364 local p
1365 p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
1366 [[ $p != /* ]] && p=$PWD
1367 echo "${p%%/.git}"
1368 }
1369
1370 g() {
1371
1372 # todo: patch emacs so it will look elsewhere. this is kinda sad:
1373 # https://emacs.stackexchange.com/questions/4253/how-to-start-emacs-with-a-custom-user-emacs-directory
1374
1375 local args gdb=false
1376
1377 if [[ $EMACSDIR ]]; then
1378 path-add "$EMACSDIR/lib-src" "$EMACSDIR/src"
1379 fi
1380
1381 if [[ $DISPLAY ]]; then
1382 args=-n
1383 fi
1384
1385 if (( $# == 0 )); then
1386 args+=" -c"
1387 fi
1388 # duplicate -c, but oh well
1389 if ! pgrep -u $EUID emacsclient; then
1390 if (( $# == 0 )) && type -p gdb &>/dev/null; then
1391 gdb=true
1392 else
1393 args+=" -c"
1394 fi
1395 fi
1396 if [[ $EMACSDIR ]]; then
1397 # Alter the path here, otherwise the nfs mount gets triggered on the
1398 # first path lookup when emacs is not being used.
1399 # shellcheck disable=SC2098 disable=SC2097 # false positive
1400 PATH="$EMACSDIR/lib-src:$EMACSDIR/src:$PATH" EHOME=$HOME HOME=$EMACSDIR m emacsclient -a "" $args "$@"
1401 else
1402 if $gdb; then
1403 # due to a bug, we cant debug from the start unless we get a new gdb
1404 # https://sourceware.org/bugzilla/show_bug.cgi?id=24454
1405 # m gdb -ex="set follow-fork-mode child" -ex=r -ex=quit --args emacs --daemon
1406 m emacsclient -a "" $args "$@"
1407 sleep 1
1408 cd "/a/opt/emacs-$(distro-name)$(distro-num)"
1409 s gdb -p "$(pgrep -f 'emacs --daemon')" -ex c
1410 cd -
1411 else
1412 m emacsclient -a "" $args "$@"
1413 fi
1414 fi
1415 }
1416
1417 # force terminal version
1418 gn() {
1419 g -n "$@"
1420 }
1421
1422 gmacs() {
1423 # quit will prompt if the program crashes.
1424 gdb -ex=r -ex=quit --args emacs "$@"; r;
1425 }
1426
1427 gdkill() {
1428 # kill the emacs daemon
1429 pk1 emacs --daemon
1430 }
1431
1432 gr() {
1433 grep -iIP --color=auto "$@" || return $?
1434 }
1435 grr() { # grep recursive
1436 # Don't return 1 on nonmatch because this is meant to be
1437 # interactive, not in a conditional.
1438 if [[ ${#@} == 1 ]]; then
1439 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" . || [[ $? == 1 ]]
1440 else
1441 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" || [[ $? == 1 ]]
1442 fi
1443 }
1444 ccomp grep gr grr
1445
1446 rg() { grr "$@"; }
1447 ccomp grep rg
1448
1449 # recursive everything. search for files/dirs and lines. rs = easy chars to press
1450 re() {
1451 local query
1452 query="$1"
1453 find "$@" -not \( -name .svn -prune -o -name .git -prune \
1454 -o -name .hg -prune -o -name .editor-backups -prune \
1455 -o -name .undo-tree-history -prune \) 2>/dev/null | grep -iP --color=auto "$query"
1456 grr -m 5 "$@"
1457 }
1458
1459 # horizontal row. used to break up output
1460 hr() {
1461 local blocks
1462 # 180 is long enough.
1463 blocks=██████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
1464 printf "%s\n" "$(tput setaf 5 2>/dev/null ||:)${blocks:0:${COLUMNS:-180}}$(tput sgr0 2>/dev/null||:)"
1465 }
1466 # highlight
1467 hl() {
1468 local col input_len=0
1469 for arg; do
1470 input_len=$((input_len + 1 + ${#arg}))
1471 done
1472 col=$((60 - input_len))
1473 printf "\e[1;97;41m%s" "$*"
1474 if (( col > 0 )); then
1475 # shellcheck disable=SC2046 # needed to work as intended. a better way would be like hr above.
1476 printf "\e[1;97;41m \e[0m%.0s" $(eval echo "{1..${col}}")
1477 fi
1478 echo
1479 }
1480 hlm() { hl "$*"; "$@"; }
1481
1482 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
1483
1484
1485 # get latest hub and run it
1486 # main command to use:
1487 # hub pull-request --no-edit
1488 # --no-edit means to use the first commit\'s message as the pull request message.
1489 # If that fails, try doing
1490 # hub pull-request --no-edit -b UPSTREAM_OWNER:branch
1491 # where branch is usually master. it does the pr against your current branch.
1492 #
1493 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
1494 # it\'s at ~/.config/hub
1495 hub() {
1496 local up uptar updir p re
1497 # example https://github.com/github/hub/releases/download/v2.14.2/hub-linux-amd64-2.14.2.tgz
1498 up=$(wget -q -O- https://api.github.com/repos/github/hub/releases/latest | jq -r .assets[].browser_download_url | grep linux-amd64)
1499 re='[[:space:]]'
1500 if [[ ! $up || $up =~ $re ]]; then
1501 echo "failed to get good update url. got: $up"
1502 fi
1503 uptar=${up##*/}
1504 updir=${uptar%.tgz}
1505 if [[ ! -e /a/opt/$updir ]]; then
1506 rm -rf /a/opt/hub-linux-amd64*
1507 wget -P /a/opt $up
1508 tar -C /a/opt -zxf /a/opt/$uptar
1509 rm -f /a/opt/$uptar
1510 fi
1511 if ! which hub &>/dev/null; then
1512 sudo /a/opt/$updir/install
1513 fi
1514
1515 # save token across computers
1516 if [[ ! -L ~/.config/hub ]]; then
1517 if [[ -e ~/.config/hub ]]; then
1518 mv ~/.config/hub /p/c/subdir_files/.config/
1519 fi
1520 if [[ -e /p/c/subdir_files/.config/hub ]]; then
1521 conflink
1522 fi
1523 fi
1524 command hub "$@"
1525 }
1526
1527 i() { git "$@"; }
1528 ccomp git i
1529
1530 # git status:
1531 # cvs -qn update
1532
1533 # git checkout FILE
1534 # cvs update -C FILE
1535
1536 # git pull
1537 # cvs up[date]
1538
1539 # potentially useful command translation
1540 # https://fling.seas.upenn.edu/~giesen/dynamic/wordpress/equivalent-commands-for-git-svn-and-cvs/
1541
1542 # importing cvs repo into git using git-cvs package:
1543 # /f/www $ /usr/lib/git-core/git-cvsimport -C /f/www-git
1544
1545 ic() {
1546 # fast commit all
1547 git commit -am "$*"
1548 }
1549
1550 ipp() {
1551 git pull
1552 git push
1553 }
1554
1555 ifn() {
1556 local glob
1557 glob="$1"
1558 shift
1559 find -L "$@" -not \( -name .svn -prune -o -name .git -prune \
1560 -o -name .hg -prune -o -name .editor-backups -prune \
1561 -o -name .undo-tree-history -prune \) -iname "*$glob*" 2>/dev/null
1562 }
1563
1564 ifh() {
1565 # insensitive find here. args are combined into the search string.
1566 # -L = follow symlinks
1567 find -L . -not \( -name .svn -prune -o -name .git -prune \
1568 -o -name .hg -prune -o -name .editor-backups -prune \
1569 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1570 }
1571
1572 ifd() {
1573 # insensitive find directory
1574 find -L . -type d -not \( -name .svn -prune -o -name .git -prune \
1575 -o -name .hg -prune -o -name .editor-backups -prune \
1576 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1577 }
1578
1579
1580 ipdrop() {
1581 sudo iptables -A INPUT -s $1 -j DROP
1582 }
1583
1584
1585 istext() {
1586 grep -Il "" "$@" &>/dev/null
1587 }
1588
1589 pst() {
1590 pstree -apnA
1591 }
1592
1593 jr() { journalctl -e -n100000 "$@" ; }
1594 jrf() { journalctl -n1000 -f "$@" ; }
1595 jru() {
1596 # the invocation id is "assigned each time the unit changes from an inactive
1597 # state into an activating or active state" man systemd.exec
1598 journalctl -e --no-tail -u exim4 _SYSTEMD_INVOCATION_ID="$(systemctl show -p InvocationID --value $1)"
1599 }
1600 ccomp journalctl jr jrf jru
1601
1602
1603
1604 l() {
1605 if [[ $PWD == /[iap] ]]; then
1606 command ls -A --color=auto -I lost+found "$@"
1607 else
1608 command ls -A --color=auto "$@"
1609 fi
1610 }
1611
1612 lcn() { locate -i "*$**"; }
1613
1614 lg() { LC_COLLATE=C.UTF-8 ll --group-directories-first "$@"; }
1615
1616 lt() { ll -tr "$@"; }
1617
1618 lld() { ll -d "$@"; }
1619
1620 ccomp ls l lg lt lld ll
1621
1622 # low recursively
1623 lowr() {
1624 local f dirs i a
1625 local -a all
1626 for dirs in false true; do
1627 for f; do
1628 if [[ -d $f ]]; then
1629 all=("$f"/**)
1630 # reverse the order to rename the nested dirs first.
1631 # note: 0 element is the dir itself
1632 for ((i=${#all[@]}-1; i>=1; i--)); do
1633 a="${all[i]}"
1634 if $dirs && [[ -d $a ]]; then
1635 # e dirs low "$a" # debug
1636 low "$a"
1637 elif ! $dirs && [[ ! -d $a && -e $a ]]; then
1638 # debug
1639 # e not dirs low "$a" # debug
1640 low "$a"
1641 fi
1642 done
1643 fi
1644 # just rename all the top level args on the second pass
1645 if $dirs; then
1646 # e final dirs low "$f" # debug
1647 low "$f"
1648 fi
1649 done
1650 done
1651 }
1652
1653 low() { # make filenames lowercase, remove bad chars
1654 local arg new dir f
1655 for arg; do
1656 arg="${arg%%+(/)}" # remove trailing slashes. assumes we have extglob on.
1657 dir="${arg%/*}"
1658 if (( ${#dir} == ${#arg} )); then
1659 dir=.
1660 fi
1661 f="${arg##*/}"
1662 new="${f,,}" # downcase
1663 # shellcheck disable=SC2031 # seems like a shellcheck bug
1664 new="${new//[^a-zA-Z0-9._-]/_}" # sub bad chars
1665 new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
1666 new="${new%"${new##*[[:alnum:]]}"}"
1667 # remove bad underscores, like __ and _._
1668 new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
1669 safe_rename "$dir/$f" "$dir/$new" || return 1
1670 done
1671 return 0
1672 }
1673
1674 lower() { # make first letter of filenames lowercase.
1675 local x
1676 for x in "$@"; do
1677 if [[ ${x::1} == [A-Z] ]]; then
1678 y=$(tr '[:upper:]' '[:lower:]' <<<"${x::1}")"${x:1}"
1679 safe_rename "$x" "$y" || return 1
1680 fi
1681 done
1682 }
1683
1684
1685 k() { # history search
1686 grep -iP --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | tail -n 80 || [[ $? == 1 ]];
1687 }
1688 ks() { # history search with context
1689 # args are an extended regex used by sed
1690 history | sed -nr "h;s/^\s*(\S+\s+){4}//;/$*/{g;p}" | tail -n 80 || [[ $? == 1 ]];
1691 }
1692 ksu() { # history search unique
1693 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | uniq || [[ $? == 1 ]];
1694 }
1695
1696 # todo: id like to do maybe a daily or hourly cronjob to
1697 # check that my history file size is increasing. Ive had it
1698 # inexplicably truncated in the past.
1699 histrm() {
1700 history -n
1701 HISTTIMEFORMAT='' history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/'
1702 read -r -p "press anything but contrl-c to delete"
1703 for entry in $(HISTTIMEFORMAT='' history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/ { print a }' | tac); do
1704 history -d $entry
1705 done
1706 history -w
1707 }
1708
1709 ccomp grep k ks ksu histrm
1710
1711
1712 make-targets() {
1713 # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
1714 make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
1715 }
1716
1717 mkc() {
1718 mkdir "$1"
1719 c "$1"
1720 }
1721 ccomp mkdir mkc
1722
1723 mkct() {
1724 mkc "$(mktemp -d)"
1725 }
1726 # mkdir the last arg, cp the rest into it
1727 mkcp() {
1728 mkdir -p "${@: -1}"
1729 cp "${@:1:$#-1}" "${@: -1}"
1730 }
1731 mkmv() {
1732 mkdir -p "${@: -1}"
1733 mv "${@:1:$#-1}" "${@: -1}"
1734 }
1735
1736 mkt() { # mkdir and touch file
1737 local path="$1"
1738 mkdir -p "$(dirname "$path")"
1739 touch "$path"
1740 }
1741
1742 # shellcheck disable=SC2032
1743 mkdir() { command mkdir -p "$@"; }
1744
1745 nags() {
1746 # https://github.com/HenriWahl/Nagstamon/issues/357
1747 if ! pgrep -f /usr/lib/notification-daemon/notification-daemon >/dev/null; then
1748 /usr/lib/notification-daemon/notification-daemon &
1749 fi
1750 /usr/bin/nagstamon &
1751 }
1752
1753 nmt() {
1754 # cant use s because sudo -i doesnt work for passwordless sudo command
1755 case $EUID in
1756 0)
1757 sudo nmtui-connect "$@"
1758 ;;
1759 *)
1760 nmtui-connect "$@"
1761 ;;
1762 esac
1763 }
1764
1765
1766 ngset() {
1767 if shopt nullglob >/dev/null; then
1768 ngreset=false
1769 else
1770 shopt -s nullglob
1771 ngreset=true
1772 fi
1773 }
1774 ngreset() {
1775 if $ngreset; then
1776 shopt -u nullglob
1777 fi
1778 }
1779
1780 nopanic() {
1781 # shellcheck disable=SC2024
1782 ngset
1783 for f in /var/log/exim4/paniclog /var/log/exim4/*panic; do
1784 base=${f##*/}
1785 if [[ -s $f ]]; then
1786 echo ================== $f =============
1787 s tee -a /var/log/exim4/$base-archive <$f
1788 s truncate -s0 $f
1789 fi
1790 done
1791 ngreset
1792 }
1793
1794
1795 ping() { command ping -O "$@"; }
1796 p8() { ping "$@" 8.8.8.8; }
1797 p6() { ping6 "$@" 2001:4860:4860::8888; }
1798
1799 pkx() { # package extract
1800 local pkg cached tmp f
1801 c "$(mktemp -d)"
1802 pkg=$1
1803 # shellcheck disable=SC2012
1804 cached=$(ls -t /var/cache/apt/archives/$pkg* | tail -n1 2>/dev/null) ||:
1805 if [[ $cached ]]; then
1806 cp $cached .
1807 else
1808 aptitude download $pkg || return 1
1809 fi
1810 tmp=(*); f=${tmp[0]} # only 1 expected
1811 ex $f
1812 rm -f $f
1813 }
1814
1815 # pgrep and kill
1816 pk1() {
1817 local tmpf
1818 local -a pids
1819 tmpf=$(pgrep -f "$*")
1820 mapfile -t pids <<<"$tmpf"
1821 case ${#pids[@]} in
1822 1)
1823 # shellcheck disable=SC2128
1824 {
1825 ps -F ${pids[0]}
1826 m kill ${pids[0]}
1827 }
1828 ;;
1829 0) echo "no pid found" ;;
1830 *)
1831 ps -F ${pids[@]}
1832 ;;
1833 esac
1834 }
1835
1836 psg () {
1837 local x y help
1838 help="Usage: psg [--help] GREP_ARGS
1839 grep ps and output in a nice format"
1840 if [[ $1 == --help ]]; then
1841 echo "$help"
1842 return
1843 fi
1844 x=$(ps -eF)
1845 # final grep is because some commands tend to have a lot of trailing spaces
1846 y=$(echo "$x" | grep -iP "$@" | grep -o '.*[^ ]') ||:
1847 if [[ $y ]]; then
1848 echo "$x" | head -n 1 || [[ $? == 141 ]]
1849 echo "$y"
1850 fi
1851 }
1852
1853 pubip() { curl -4s https://icanhazip.com; }
1854 pubip6() { curl -6s https://icanhazip.com; }
1855 whatismyip() { pubip; }
1856
1857
1858 q() { # start / launch a program in the backround and redir output to null
1859 "$@" &> /dev/null &
1860 }
1861
1862 # shellcheck disable=SC2120
1863 r() {
1864 if [[ $HISTFILE ]]; then
1865 history -a # save history
1866 fi
1867 trap ERR # this avoids a segfault
1868 exit ${1:0}
1869 # i had this redir, not sure why
1870 # exit "$@" 2>/dev/null
1871 }
1872
1873 # scp is insecure and deprecated.
1874 scp() {
1875 rsync -Pt --inplace "$@"
1876 }
1877 ccomp rsync scp
1878
1879 randport() {
1880 # available high ports are 1024-65535,
1881 # but lets skip things that are more likely to be in use
1882 python3 <<'EOF'
1883 import secrets
1884 print(secrets.SystemRandom().randrange(10002,65500))
1885 EOF
1886 }
1887
1888 # reapply bashrc
1889 reb() {
1890 # shellcheck disable=SC1090 # expected to not follow
1891 source ~/.bashrc
1892 }
1893
1894 rl() {
1895 readlink -f "$@"
1896 }
1897 ccomp readlink rl
1898
1899 rsd() {
1900 # rsync, root is required to keep permissions right.
1901 # rsync --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
1902 # --no-times --delete
1903 # basically, make an exact copy, use checksums instead of file times to be more accurate
1904 rsync -ahvic --delete "$@"
1905 }
1906 rsa() {
1907 # like rlu, but dont delete files on the target end which
1908 # do not exist on the original end.
1909 rsync -ahvic "$@"
1910 }
1911 rst() {
1912 # rl without preserving modification time.
1913 rsync -ahvic --delete --no-t "$@"
1914 }
1915 # [RSYNC_OPTS] HOST PATH
1916 rsu() {
1917 # eg. rsu -opts frodo /testpath
1918 # relative paths will expanded with readlink -f.
1919 opts=("${@:1:$#-2}") # 1 to last -2
1920 path="${*:$#}" # last
1921 host="${*:$#-1:1}" # last -1
1922 if [[ $path == .* ]]; then
1923 path=$(readlink -f $path)
1924 fi
1925 m rsync -ahvi --relative --no-implied-dirs "${opts[@]}" "$path" "root@$host:/";
1926 }
1927 ccomp rsync rsd rsa rst rsu
1928
1929 # find programs listening on a port
1930 ssp() {
1931 local port=$1
1932 # to figure out these args, i had to look at the man page from git version, as of 2022-04.
1933 s ss -lpn state listening sport = $port
1934 }
1935
1936 resolvcat() {
1937 local f
1938 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1939 m s nscd -i hosts
1940 fi
1941 f=/etc/resolv.conf
1942 echo $f:; ccat $f
1943 hr; s ss -lpn sport = 53
1944 if systemctl is-enabled dnsmasq &>/dev/null || [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1945 # this will fail is dnsmasq is failed
1946 hr; m ser status dnsmasq | cat || :
1947 f=/etc/dnsmasq.conf
1948 hr; echo $f:; ccat $f
1949 hr; m grr '^ *(servers-file|server) *=|^ *no-resolv *$' /etc/dnsmasq.conf /etc/dnsmasq.d
1950 f=/etc/dnsmasq-servers.conf
1951 hr; echo $f:; ccat $f
1952 fi
1953 hr
1954 echo /etc/nsswitch.conf:
1955 grep '^ *hosts:' /etc/nsswitch.conf
1956 if systemctl is-enabled systemd-resolved &>/dev/null || [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1957 hr; m ser status systemd-resolved | cat || :
1958 hr; m resolvectl status | cat
1959 fi
1960
1961 }
1962 rcat() {
1963 resolvcat | less
1964 }
1965 reresolv() {
1966 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1967 m ser stop nscd
1968 sleep .5
1969 m ser start nscd
1970 m sudo nscd -i hosts
1971 fi
1972 if [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1973 m sudo systemctl restart dnsmasq
1974 fi
1975 if [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1976 m sudo systemctl restart systemd-resolved
1977 fi
1978 if type -P resolvectl &>/dev/null; then
1979 resolvectl flush-caches
1980 fi
1981 }
1982
1983 # add annoyingly long argument which should be the default
1984 sedi() {
1985 sed -i --follow-symlinks "$@"
1986 }
1987
1988 rmstrips() {
1989 ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
1990 }
1991
1992 urun () {
1993 umask $1
1994 shift
1995 "$@"
1996 }
1997 sudo () {
1998 command sudo "$@" || return $?
1999 DID_SUDO=true
2000 }
2001 s() {
2002 # background
2003 # I use a function because otherwise we cant use in a script,
2004 # cant assign to variable.
2005 #
2006 # note: gksudo is recommended for X apps because it does not set the
2007 # home directory to the same, and thus apps writing to ~ fuck things up
2008 # with root owned files.
2009 #
2010 if [[ $EUID != 0 || $1 == -* ]]; then
2011 # shellcheck disable=SC2034
2012 SUDOD="$PWD" command sudo -i "$@"
2013 DID_SUDO=true
2014 else
2015 "$@"
2016 fi
2017 }
2018 sb() { # sudo bash -c
2019 # use sb instead of s is for sudo redirections,
2020 # eg. sb 'echo "ok fine" > /etc/file'
2021 # shellcheck disable=SC2034
2022 local SUDOD="$PWD"
2023 sudo -i bash -c "$@"
2024 }
2025 # secret sudo
2026 se() { s urun 0077 "$@"; }
2027 ccomp sudo s sb se
2028
2029 safe_rename() { # warn and dont rename if file exists.
2030 # mv -n exists, but it\'s silent
2031 if [[ $# != 2 ]]; then
2032 echo safe_rename error: $# args, need 2 >&2
2033 return 1
2034 fi
2035 if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
2036 if [[ -e $2 || -L $2 ]]; then
2037 echo "Cannot rename $1 to $2 as it already exists."
2038 else
2039 mv -vi "$1" "$2"
2040 fi
2041 fi
2042 }
2043
2044
2045 sd() {
2046 sudo dd status=none of="$1"
2047 }
2048
2049 ser() {
2050 if type -p systemctl &>/dev/null; then
2051 s systemctl "$@"
2052 else
2053 if (( $# >= 3 )); then
2054 echo iank: ser expected 2 or less arguments
2055 return 1
2056 fi
2057 s service $2 $1
2058 fi
2059 }
2060 serstat() {
2061 systemctl -n 40 status "$@"
2062 }
2063
2064 seru() { systemctl --user "$@"; }
2065 # like restart, but do nothing if its not already started
2066 srestart() {
2067 local service=$1
2068 if [[ $(s systemctl --no-pager show -p ActiveState $service ) == ActiveState=active ]]; then
2069 systemctl restart $service
2070 fi
2071 }
2072
2073 setini() { # set a value in a .ini style file
2074 key="$1" value="$2" section="$3" file="$4"
2075 if [[ -s $file ]]; then
2076 sed -ri -f - "$file" <<EOF
2077 # remove existing keys
2078 / *\[$section\]/,/^ *\[[^]]+\]/{/^\s*${key}[[:space:]=]/d}
2079 # add key
2080 /^\s*\[$section\]/a $key=$value
2081 # from section to eof, do nothing
2082 /^\s*\[$section\]/,\$b
2083 # on the last line, if we haven't found section yet, add section and key
2084 \$a [$section]\\
2085 $key=$value
2086 EOF
2087 else
2088 cat >"$file" <<EOF
2089 [$section]
2090 $key=$value
2091 EOF
2092 fi
2093 }
2094
2095 sgo() { # service go
2096 service=$1
2097 ser restart $service || return 1
2098 if type -p systemctl &>/dev/null; then
2099 ser enable $service
2100 fi
2101 }
2102 soff () {
2103 for service; do
2104 # ignore services that dont exist
2105 if systemctl cat $service &>/dev/null; then
2106 ser stop $service;
2107 ser disable $service
2108 fi
2109 done
2110 }
2111
2112 sgu() {
2113 systemctl list-unit-files | rg "$@"
2114 }
2115
2116
2117 sk() {
2118 # disable a warning with:
2119 # shellcheck disable=SC2206 # reasoning
2120
2121 # see bash-template/style-guide.md for justifications
2122
2123 local quotes others
2124 quotes=2048,2068,2086,2206
2125 others=2029,2033,2054,2164
2126 shellcheck -W 999 -x -e $quotes,$others "$@" || return $?
2127 }
2128
2129 skgit() {
2130 local f
2131 for f in $(i s | awk '$1 == "modified:" {print $2}'); do
2132 if [[ $(head -n1 "$f") == '#!/bin/bash'* ]]; then
2133 sk $f
2134 fi
2135 done
2136 }
2137
2138 # sl: ssh, but firsh rsync our bashrc and related files to a special
2139 # directory on the remote host if needed.
2140
2141 # Some environment variables and files need to be setup for this to work
2142 # (mine are set at the beginning of this file)
2143
2144 # SL_FILES_DIR: Environment variable. Path to folder which should at
2145 # least have a .bashrc file or symlink. This dir will be rsynced to ~ on
2146 # remote hosts (top level symlinks are resolved) unless the host already
2147 # has a $SL_FILES_DIR/.bashrc. In that case, we assume it is a host you
2148 # control and sync files to separately and already has the ~/.bashrc you
2149 # want. The remote bash will also take its .inputrc config from this
2150 # folder (default of not existing is fine). Mine looks like this:
2151 # https://iankelling.org/git/?p=distro-setup;a=tree;f=sl/.iank
2152
2153 # SL_INFO_DIR: Environment variable. This folder stores info about what
2154 # we detected on the remote system and when we last synced. It will be created
2155 # if it does not exist. Sometimes you may want to forget about a
2156 # remote system, you can use sl --rsync, or the function for that slr
2157 # below.
2158
2159 # SL_TEST_CMD: Env var. Meant to be used to vary the files synced
2160 # depending on the remote host. Run this string on the remote host the
2161 # first time sl is run (or if we run slr). The result is passed to
2162 # SL_TEST_HOOK. For example,
2163 # export SL_TEST_CMD=". /etc/os-release ; echo \${VERSION//[^a-zA-Z0-9]/}"
2164
2165 # SL_TEST_HOOK: Env var. It is run as $SL_TEST_HOOK. This can set
2166 # $SL_FILES_DIR to vary the files synced.
2167
2168 # SL_RSYNC_ARGS: Env var. String of arguments passed to rsync. For
2169 # example to exclude files within a directory. Note, excluded
2170 # files wont be deleted on rsync, you can add --delete-excluded
2171 # to the rsync command if that is desired.
2172
2173 # SL_SSH_ARGS: Env var. Default arguments passed to ssh.
2174
2175 # For when ~/.bashrc is already customized on the remote server, you
2176 # might find it problematic that ~/.bashrc is sourced for ALL ssh
2177 # commands, even in scripts. This paragraph is all about that. bash
2178 # scripts dont source ~/.bashrc, but call ssh in scripts and you get
2179 # ~/.bashrc. You dont want this. .bashrc is meant for interactive shells
2180 # and if you customize it, probably has bugs from time to time. This is
2181 # bad. Here's how I fix it. I have a special condition to "return" in my
2182 # .bashrc for noninteractive ssh shells (copy that code). Then use this
2183 # function or similar that passes LC_USEBASHRC=t when sshing and I want
2184 # my bashrc. Also, I don't keep most of my bashrc in .bashrc, i source a
2185 # separate file because even if I return early on, the whole file gets
2186 # parsed which can fail if there is a syntax error.
2187 sl() {
2188 # Background on LC_USEBASHRC var (no need to read if you just want to
2189 # use this function): env variables sent across ssh are strictly
2190 # limited, but we get LC_* at least in debian based machines, so we
2191 # just make that * be something no normal program would use. Note, on
2192 # hosts that dont allow LC_* I start an inner shell with LC_USEBASHRC
2193 # set, and the inner shell also allows running a nondefault
2194 # .bashrc. This means the outer shell still ran the default .bashrc,
2195 # but that is the best we can do.
2196
2197 local now args remote dorsync haveinfo tmpa sshinfo tmp tmp2 type info_sec force_rsync \
2198 sync_dirname testcmd extra_info testbool files_sec sl_test_cmd sl_test_hook
2199 declare -a args tmpa
2200
2201 args=($SL_SSH_ARGS)
2202
2203 # ssh [-1246Antivivisectionist] [-b bind_address] [-c cipher_spec] [-D [bind_address:]port]
2204 # [-E log_file] [-e escape_char] [-F configfile] [-I pkcs11] [-i identity_file] [-L address]
2205 # [-l login_name] [-m mac_spec] [-O ctl_cmd] [-o option] [-p port] [-Q query_option]
2206 # [-R address] [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]] [user@]hostname
2207 # [command]
2208
2209 # ssh [-46AaCfGgKkMNnqsTtVvXxYy] [-b bind_address] [-c cipher_spec]
2210 # [-D [bind_address:]port] [-E log_file] [-e escape_char]
2211 # [-F configfile] [-I pkcs11] [-i identity_file]
2212 # [-J [user@]host[:port]] [-L address] [-l login_name] [-m mac_spec]
2213 # [-O ctl_cmd] [-o option] [-p port] [-Q query_option] [-R address]
2214 # [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]]
2215
2216 force_rsync=false
2217 if [[ $1 == --rsync ]]; then
2218 force_rsync=true
2219 shift
2220 fi
2221 # shellcheck disable=SC2153 # intentional
2222 sl_test_cmd=$SL_TEST_CMD
2223 # shellcheck disable=SC2153 # intentional
2224 sl_test_hook=$SL_TEST_HOOK
2225 # shellcheck disable=SC2153 # intentional
2226 sl_rsync_args=$SL_RSYNC_ARGS
2227 while [[ $1 ]]; do
2228 case "$1" in
2229 --rsync)
2230 force_rsync=true
2231 ;;
2232 --sl-test-cmd)
2233 sl_test_cmd="$2"
2234 shift
2235 ;;
2236 --sl-test-hook)
2237 sl_test_hook="$2"
2238 shift
2239 ;;
2240 --sl-rsync-args)
2241 sl_rsync_args="$2"
2242 shift
2243 ;;
2244 *)
2245 break
2246 ;;
2247 esac
2248 shift
2249 done
2250
2251 while [[ $1 ]]; do
2252 case "$1" in
2253 # note we dont support things like -4oOption
2254 -[46AaCfGgKkMNnqsTtVvXxYy]*)
2255 args+=("$1"); shift
2256 ;;
2257 -[bcDEeFIiJLlmOopQRSWw]*)
2258 # -oOption etc is valid
2259 if (( ${#1} >= 3 )); then
2260 args+=("$1"); shift
2261 else
2262 args+=("$1" "$2"); shift 2
2263 fi
2264 ;;
2265 *)
2266 break
2267 ;;
2268 esac
2269 done
2270 remote="$1"
2271 if [[ ! $remote ]]; then
2272 echo $0: error hostname required >&2
2273 return 1
2274 fi
2275 shift
2276
2277 if [[ ! $SL_INFO_DIR ]]; then
2278 echo 'error: missing SL_INFO_DIR env var' >&2
2279 return 1
2280 fi
2281
2282 dorsync=false
2283 haveinfo=false
2284 tmpa=($SL_INFO_DIR/???????????"$remote")
2285 sshinfo=${tmpa[0]}
2286 if [[ -e $sshinfo ]]; then
2287 if $force_rsync; then
2288 rm -f $sshinfo
2289 else
2290 haveinfo=true
2291 fi
2292 fi
2293 if $haveinfo; then
2294 tmp=${sshinfo[0]##*/}
2295 tmp2=${tmp::11}
2296 type=${tmp2: -1}
2297 extra_info=$(cat $sshinfo)
2298 else
2299 # we test for string to know ssh succeeded
2300 testbool="test -e $SL_FILES_DIR/.bashrc -a -L .bashrc -a -v LC_USEBASHRC"
2301 testcmd="if $testbool; then printf y; else printf n; fi"
2302 if ! tmp=$(LC_USEBASHRC=y command ssh "${args[@]}" "$remote" "$testcmd; $sl_test_cmd"); then
2303 echo failed sl test. doing plain ssh -v
2304 command ssh -v "${args[@]}" "$remote"
2305 fi
2306 if [[ $tmp == y* ]]; then
2307 type=a
2308 else
2309 dorsync=true
2310 type=b
2311 fi
2312 extra_info="${tmp:1}"
2313 fi
2314 if [[ $sl_test_hook ]]; then
2315 RSYNC_RSH="ssh ${args[*]}" $sl_test_hook "$extra_info" "$remote"
2316 fi
2317
2318 if $haveinfo && [[ $type == b ]]; then
2319 info_sec=${tmp::10}
2320 read -r files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]] )
2321 files_sec=${files_sec%%.*}
2322 if (( files_sec > info_sec )); then
2323 dorsync=true
2324 rm -f $sshinfo
2325 fi
2326 fi
2327
2328 sync_dirname=${SL_FILES_DIR##*/}
2329
2330 if [[ ! $SL_FILES_DIR ]]; then
2331 echo 'error: missing SL_FILES_DIR env var' >&2
2332 return 1
2333 fi
2334
2335 if $dorsync; then
2336 RSYNC_RSH="ssh ${args[*]}" m rsync -rptL --delete $sl_rsync_args $SL_FILES_DIR "$remote":
2337 fi
2338 if $dorsync || ! $haveinfo; then
2339 sshinfo=$SL_INFO_DIR/$EPOCHSECONDS$type"$remote"
2340 [[ -e $SL_INFO_DIR ]] || mkdir -p $SL_INFO_DIR
2341 printf "%s\n" "$extra_info" >$sshinfo
2342 chmod 666 $sshinfo
2343 fi
2344 if [[ $type == b ]]; then
2345 if (( ${#@} )); then
2346 # Theres a couple ways to pass arguments, im not sure whats best,
2347 # but relying on bash 4.4+ escape quoting seems most reliable.
2348 command ssh "${args[@]}" "$remote" \
2349 LC_USEBASHRC=t bash -c '.\ '$sync_dirname'/.bashrc\;"\"\$@\""' bash ${@@Q}
2350 elif [[ ! -t 0 ]]; then
2351 # This case is when commands are being piped to ssh.
2352 # Normally, no bashrc gets sourced.
2353 # But, since we are doing all this, lets source it because we can.
2354 cat <(echo . $sync_dirname/.bashrc) - | command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
2355 else
2356 command ssh -t "${args[@]}" "$remote" LC_USEBASHRC=t INPUTRC=$sync_dirname/.inputrc bash --rcfile $sync_dirname/.bashrc
2357 fi
2358 else
2359 if [[ -t 0 ]]; then
2360 LC_USEBASHRC=t command ssh "${args[@]}" "$remote" ${@@Q}
2361 else
2362 command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
2363 fi
2364 fi
2365 # this function inspired from https://github.com/Russell91/sshrc
2366 }
2367
2368 slr() {
2369 sl --rsync "$@"
2370 }
2371 sss() { # ssh solo
2372 sl -oControlMaster=no -oControlPath=/ "$@"
2373 }
2374 # kill off old shared socket then ssh
2375 ssk() {
2376 m ssh -O exit "$@" || [[ $? == 255 ]]
2377 m sl "$@"
2378 }
2379 ccomp ssh sl slr sss ssk
2380 # plain ssh
2381 ssh() {
2382 if [[ $TERM == alacritty || $TERM == xterm-kitty ]]; then
2383 TERM=xterm-256color LC_USEBASHRC=t command ssh "$@"
2384 else
2385 LC_USEBASHRC=t command ssh "$@"
2386 fi
2387 }
2388
2389
2390 slog() {
2391 # log with script. timing is $1.t and script is $1.s
2392 # -l to save to ~/typescripts/
2393 # -t to add a timestamp to the filenames
2394 local logdir do_stamp arg_base
2395 (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
2396 logdir="/a/dt/"
2397 do_stamp=false
2398 while getopts "lt" option
2399 do
2400 case $option in
2401 l) arg_base=$logdir ;;
2402 t) do_stamp=true ;;
2403 *)
2404 echo error: bad option
2405 return 1
2406 ;;
2407 esac
2408 done
2409 shift $((OPTIND - 1))
2410 arg_base+=$1
2411 [[ -e $logdir ]] || mkdir -p $logdir
2412 $do_stamp && arg_base+=$(date +%F.%T%z)
2413 script -t $arg_base.s 2> $arg_base.t
2414 }
2415 splay() { # script replay
2416 #logRoot="$HOME/typescripts/"
2417 #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
2418 scriptreplay "$1.t" "$1.s"
2419 }
2420
2421 sr() {
2422 # sudo redo. be aware, this command may not work right on strange distros or earlier software
2423 if [[ $# == 0 ]]; then
2424 sudo -E bash -c -l "$(history -p '!!')"
2425 else
2426 echo this command redos last history item. no argument is accepted
2427 fi
2428 }
2429
2430 srm () {
2431 # with -ll, less secure but faster.
2432 command srm -ll "$@"
2433 }
2434
2435 srun() {
2436 scp $2 $1:/tmp
2437 ssh $1 "/tmp/${2##*/}" "$(printf "%q\n" "${@:2}")"
2438 }
2439
2440
2441 swap() {
2442 local tmp
2443 tmp=$(mktemp)
2444 mv $1 $tmp
2445 mv $2 $1
2446 mv $tmp $2
2447 }
2448
2449 tclock() { # terminal clock
2450 local x
2451 clear
2452 date +%l:%_M
2453 len=60
2454 # this goes to full width
2455 #len=${1:-$((COLUMNS -7))}
2456 x=1
2457 while true; do
2458 if (( x == len )); then
2459 end=true
2460 d="$(date +%l:%_M) "
2461 else
2462 end=false
2463 d=$(date +%l:%M:%_S)
2464 fi
2465 echo -en "\r"
2466 echo -n "$d"
2467 for ((i=0; i<x; i++)); do
2468 if (( i % 6 )); then
2469 echo -n _
2470 else
2471 echo -n .
2472 fi
2473 done
2474 if $end; then
2475 echo
2476 x=1
2477 else
2478 x=$((x+1))
2479 fi
2480 sleep 5
2481 done
2482 }
2483
2484
2485 te() {
2486 # test existence / exists
2487 local ret=0
2488 for x in "$@"; do
2489 [[ -e "$x" || -L "$x" ]] || ret=1
2490 done
2491 return $ret
2492 }
2493
2494 psoff() {
2495 # normally, i would just execute these commands in the function.
2496 # however, DEBUG is not inherited, so we need to run it outside a function.
2497 # And we want to run set -x afterwards to avoid spam, so we cram everything
2498 # in here, and then it will run after this function is done.
2499 # # set as array to satisfy shellcheck, but it is equivalent to setting it as non-array
2500 PROMPT_COMMAND=('trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "')
2501 }
2502 pson() {
2503 PROMPT_COMMAND=(prompt-command)
2504 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2505 trap 'settitle "$BASH_COMMAND"' DEBUG
2506 fi
2507 }
2508
2509 # prometheus node curl
2510 pnodecurl() {
2511 local host
2512 host=${1:-127.0.0.1}
2513 s curl --cert-type PEM --cert /etc/prometheus/ssl/prometheus_cert.pem --key /etc/prometheus/ssl/prometheus_key.pem --cacert /etc/prometheus/ssl/prom_node_cert.pem --resolve prom_node:9100:$host -v https://prom_node:9100/metrics
2514 }
2515
2516 tx() { # toggle set -x, and the prompt so it doesnt spam
2517 if [[ $- == *x* ]]; then
2518 set +x
2519 pson
2520 else
2521 psoff
2522 fi
2523 }
2524
2525 psnetns() {
2526 # show all processes in the network namespace $1.
2527 # blank entries appear to be subprocesses/threads
2528 local x netns
2529 netns=$1
2530 ps -w | head -n 1
2531 sudo find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
2532 while read -r l; do
2533 x=$(ps -w --no-headers -p $l);
2534 if [[ $x ]]; then echo "$x"; else echo $l; fi;
2535 done
2536 }
2537 nonet() {
2538 if ! s ip netns list | grep -Fx nonet &>/dev/null; then
2539 s ip netns add nonet
2540 fi
2541 sudo -E env /sbin/ip netns exec nonet sudo -E -u iank /bin/bash
2542 }
2543
2544 m() { printf "%s\n" "$*"; "$@"; }
2545
2546 # update file. note: duplicated in mail-setup.
2547 # updates $ur u result to true or false
2548 # updates $reload to true if file updated is in /etc/systemd/system
2549 u() {
2550 local tmp tmpdir dest="$1"
2551 local base="${dest##*/}"
2552 local dir="${dest%/*}"
2553 if [[ $dir != "$base" ]]; then
2554 # dest has a directory component
2555 mkdir -p "$dir"
2556 fi
2557 # shellcheck disable=SC2034 # see comment at top of function
2558 ur=false # u result
2559 tmpdir="$(mktemp -d)"
2560 cat >$tmpdir/"$base"
2561 tmp=$(rsync -ic $tmpdir/"$base" "$dest")
2562 if [[ $tmp ]]; then
2563 printf "%s\n" "$tmp"
2564 # shellcheck disable=SC2034 # see comment at top of function
2565 ur=true
2566 if [[ $dest == /etc/systemd/system/* ]]; then
2567 # shellcheck disable=SC2034 # see comment at top of function
2568 reload=true
2569 fi
2570 fi
2571 rm -rf $tmpdir
2572 }
2573
2574
2575 uptime() {
2576 if type -p uprecords &>/dev/null; then
2577 uprecords -B
2578 else
2579 command uptime
2580 fi
2581 }
2582
2583 virshrm() {
2584 for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
2585 }
2586
2587 vm-set-listen(){
2588 local t
2589 t=$(mktemp)
2590 local vm=$1
2591 local ip=$2
2592 sudo virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
2593 sed -r "s/listen='[^']+/listen='$ip/"> $t
2594 sudo virsh undefine $vm
2595 sudo virsh define $t
2596 }
2597
2598
2599 vmshare() {
2600 vm-set-listen $1 0.0.0.0
2601 }
2602
2603
2604 vmunshare() {
2605 vm-set-listen $1 127.0.0.1
2606 }
2607
2608 myiwscan() {
2609 # find input, copy to pattern space, when we find the first field, print the copy in different order without newlines.
2610 # instead of using labels, we could just match a line and group, eg: /signal:/,{s/signal:(.*)/\1/h}
2611 sudo iw dev wls1 scan | sed -rn "
2612 s/^\Wcapability: (.*)/\1/;Ta;h;b
2613 :a;s/^\Wsignal: -([^.]+).*/\1/;Tb;H;b
2614 # padded to min width of 20
2615 :b;s/\WSSID: (.*)/\1 /;T;s/^(.{20}(.*[^ ])?) */\1/;H;g;s/(.*)\n(.*)\n(.*)/\2 \3 \1/gp;b
2616 "|sort -r
2617 }
2618
2619 # Run script by copying it to a temporary location first,
2620 # and changing directory, so we don't have any open
2621 # directories or files that could cause problems when
2622 # remounting.
2623 zr() {
2624 local tmp
2625 tmp=$(type -p "$1")
2626 if [[ $tmp ]]; then
2627 cd "$(mktemp -d)"
2628 cp -a "$tmp" .
2629 shift
2630 ./"${tmp##*/}" "$@"
2631 else
2632 "$@"
2633 fi
2634 }
2635
2636
2637 # * spark
2638 # spark 1 5 22 13 53
2639 # # => ▁▁▃▂▇
2640
2641 # The MIT License
2642 # Copyright (c) Zach Holman, https://zachholman.com
2643 # https://github.com/holman/spark
2644
2645 # As of 2022-10-28, I reviewed github forks that had several newer
2646 # commits, none had anything interesting. I did a little refactoring
2647 # mostly to fix emacs indent bug.
2648
2649 # Generates sparklines.
2650 _spark_echo()
2651 {
2652 if [ "X$1" = "X-n" ]; then
2653 shift
2654 printf "%s" "$*"
2655 else
2656 printf "%s\n" "$*"
2657 fi
2658 }
2659
2660
2661 spark()
2662 {
2663 local f tc
2664 local n numbers=
2665
2666 # find min/max values
2667 local min=0xffffffff max=0
2668
2669 for n in ${@//,/ }
2670 do
2671 # on Linux (or with bash4) we could use `printf %.0f $n` here to
2672 # round the number but that doesn't work on OS X (bash3) nor does
2673 # `awk '{printf "%.0f",$1}' <<< $n` work, so just cut it off
2674 n=${n%.*}
2675 (( n < min )) && min=$n
2676 (( n > max )) && max=$n
2677 numbers=$numbers${numbers:+ }$n
2678 done
2679
2680 # print ticks
2681 local ticks=(▁ ▂ ▃ ▄ ▅ ▆ ▇ █)
2682
2683 # use a high tick if data is constant
2684 (( min == max )) && ticks=(▅ ▆)
2685
2686 tc=${#ticks[@]}
2687 f=$(( ( (max-min) <<8)/( tc - 1) ))
2688 (( f < 1 )) && f=1
2689
2690 for n in $numbers
2691 do
2692 _spark_echo -n ${ticks[$(( (((n-min)<<8)/f) ))]}
2693 done
2694 _spark_echo
2695 }
2696
2697 pdfwc() { local f; for f; do echo "$f" "$(pdfinfo "$f" | awk '/^Pages:/ {print $2}')"; done }
2698
2699 # * misc stuff
2700
2701
2702 if $use_color && type -p tput &>/dev/null; then
2703 term_bold="$(tput bold)"
2704 term_red="$(tput setaf 1)"
2705 term_green="$(tput setaf 2)"
2706 # shellcheck disable=SC2034 # expected
2707 term_yellow="$(tput setaf 3)"
2708 term_purple="$(tput setaf 5)"
2709 term_nocolor="$(tput sgr0)" # no font attributes
2710
2711 # unused so far. commented for shellcheck
2712 # term_underl="$(tput smul)"
2713 # term_blue="$(tput setaf 4)"
2714 # term_cyan="$(tput setaf 6)"
2715 fi
2716 # Try to keep environment pollution down, EPA loves us.
2717 unset safe_term match_lhs use_color
2718
2719 # * prompt
2720
2721
2722 if [[ $- == *i* ]]; then
2723
2724
2725 case $HOSTNAME in
2726 bk|je|li)
2727 if [[ $EUID == 1000 ]]; then
2728 system-status _ ||:
2729 fi
2730 ;;
2731 esac
2732
2733
2734 # this needs to come before next ps1 stuff
2735 # this stuff needs bash 4, feb 2009,
2736 # old enough to no longer condition on $BASH_VERSION anymore
2737 shopt -s autocd
2738 shopt -s dirspell
2739 PS1='\w'
2740 if [[ $- == *i* ]] && [[ ! $LC_INSIDE_EMACS ]]; then
2741 PROMPT_DIRTRIM=2
2742 bind -m vi-command B:shell-backward-word
2743 bind -m vi-command W:shell-forward-word
2744 fi
2745
2746 if [[ $SSH_CLIENT || $SUDO_USER ]]; then
2747 unset PROMPT_DIRTRIM
2748 PS1="\h:$PS1"
2749 fi
2750
2751 # emacs terminal has problems if this runs slowly,
2752 # so I've thrown a bunch of things at the wall to speed it up.
2753 prompt-command() {
2754 local return=$? # this MUST COME FIRST
2755 local ps_char ps_color
2756 unset IFS
2757
2758 if [[ $HISTFILE ]]; then
2759 history -a # save history
2760 fi
2761
2762 case $return in
2763 0) ps_color="$term_purple"
2764 ps_char='\$'
2765 ;;
2766 *) ps_color="$term_green"
2767 ps_char="$return \\$"
2768 ;;
2769 esac
2770 if [[ ! -O . ]]; then # not owner
2771 if [[ -w . ]]; then # writable
2772 ps_color="$term_bold$term_red"
2773 else
2774 ps_color="$term_bold$term_green"
2775 fi
2776 fi
2777
2778 # faster than sourceing the file im guessing
2779 if [[ -e /dev/shm/iank-status && ! -e /tmp/quiet-status ]]; then
2780 eval "$(< /dev/shm/iank-status)"
2781 fi
2782 if [[ $MAIL_HOST && $MAIL_HOST != "$HOSTNAME" ]]; then
2783 ps_char="@ $ps_char"
2784 fi
2785 jobs_char=
2786 if [[ $(jobs -p) ]]; then
2787 jobs_char='j\j '
2788 fi
2789 # We could test if sudo is active with sudo -nv
2790 # but then we get an email and log of lots of failed sudo commands.
2791 # We could turn those off, but seems better not to.
2792 if [[ $EUID != 0 ]] && [[ $DID_SUDO ]]; then
2793 psudo="\[$term_bold$term_red\]s\[$term_nocolor\] "
2794 fi
2795 if [[ ! $HISTFILE ]]; then
2796 ps_char="NOHIST $ps_char"
2797 fi
2798 PS1="${PS1%"${PS1#*[wW]}"} $jobs_char$psudo\[$ps_color\]$ps_char\[$term_nocolor\] "
2799
2800 # set titlebar. instead, using more advanced
2801 # titelbar below
2802 #echo -ne "$_title_escape $HOSTNAME ${PWD/#$HOME/~} \007"
2803 }
2804 PROMPT_COMMAND=(prompt-command)
2805
2806 if [[ $TERM == screen* ]]; then
2807 _title_escape="\033]..2;"
2808 else
2809 # somme sites recommend this, i dunno what the diff is.
2810 #_title_escape="\033]30;"
2811 _title_escape="\033]0;"
2812 fi
2813
2814 # make the titlebar be the last command and the current directory.
2815 settitle () {
2816
2817
2818 # These are some checks to help ensure we dont set the title at
2819 # times that the debug trap is running other than the case we
2820 # want. Some of them might not be needed.
2821 if (( ${#FUNCNAME[@]} != 1 || ${#BASH_ARGC[@]} != 2 || BASH_SUBSHELL != 0 )); then
2822 return 0
2823 fi
2824 if [[ $1 == prompt-command ]]; then
2825 return 0
2826 fi
2827 echo -ne "$_title_escape ${PWD/#$HOME/~} "
2828 printf "%s" "$*"
2829 echo -ne "\007"
2830 }
2831
2832 # note, this wont work:
2833 # x=$(mktemp); cp a $x
2834 # I havnt figured out why, bigger fish to fry.
2835 #
2836 # for titlebar.
2837 # condition from the screen man page i think.
2838 # note: duplicated in tx()
2839 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2840 trap 'settitle "$BASH_COMMAND"' DEBUG
2841 else
2842 trap DEBUG
2843 fi
2844
2845 fi
2846
2847 # * stuff that makes sense to be at the end
2848
2849
2850 # best practice
2851 unset IFS
2852
2853 if [[ -s "$HOME/.rvm/scripts/rvm" ]]; then
2854 # shellcheck disable=SC1091
2855 source "$HOME/.rvm/scripts/rvm"
2856 fi
2857
2858 # I had this idea to start a bash shell which would run an initial
2859 # command passed through this env variable, then continue on
2860 # interactively. But the use case I had in mind went away.
2861 #
2862 # if [[ $MY_INIT_CMD ]]; then
2863 # "${MY_INIT_CMD[@]}"
2864 # unset MY_INIT_CMD
2865 # fi
2866
2867 # ensure no bad programs appending to this file will have an affect
2868 return 0